from scapy.layers.inet import IP, TCP
from scapy.layers.l2 import Ether

UNDEFINED = 'Undefined'
def initiate_database(connection):
    connection.sql("CREATE TABLE IF NOT EXISTS packets ("
                   "source_ip VARCHAR, "
                   "destination_ip VARCHAR, "
                   "source_mac VARCHAR, "
                   "destination_mac VARCHAR, "
                   "source_port VARCHAR, "
                   "destination_port VARCHAR, "
                   "is_dangerous BOOLEAN, "
                   "type_of_threat VARCHAR)")
def add_address(connection, packet):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)
    is_dangerous = False
    type_of_threat = 'None'

    if not contains_address(connection, packet):
        connection.sql(f"INSERT INTO packets VALUES ("
                           f"'{source_ip}', "
                           f"'{destination_ip}', "
                           f"'{source_mac}', "
                           f"'{destination_mac}', "
                           f"'{source_port}', "
                           f"'{destination_port}', "
                           f"{is_dangerous}, "
                           f"'{type_of_threat}')")

def update_address(connection, packet, is_dangerous, type_of_threat):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)

    connection.sql(f"UPDATE packets SET "
                       f"is_dangerous = {is_dangerous}, "
                       f"type_of_threat = '{type_of_threat}' "
                       f"WHERE source_ip = '{source_ip}' AND "
                       f"destination_ip = '{destination_ip}' AND "
                       f"source_mac = '{source_mac}' AND "
                       f"destination_mac = '{destination_mac}' AND "
                       f"source_port = '{source_port}' AND "
                       f"destination_port = '{destination_port}'")



def contains_address(connection, packet):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)

    contains = connection.sql(f"SELECT EXISTS ( FROM packets WHERE "
                              f"source_ip = '{source_ip}' AND "
                              f"destination_ip = '{destination_ip}' AND "
                              f"source_mac = '{source_mac}' AND "
                              f"destination_mac = '{destination_mac}' AND "
                              f"source_port = '{source_port}' AND "
                              f"destination_port = '{destination_port}')").fetchone()[0]

    return contains

def contains_malicious_address(connection, packet):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)

    contains = connection.sql(f"SELECT EXISTS ( FROM packets "
                              f"WHERE is_dangerous = 'True'"
                              f"AND source_ip = '{source_ip}')").fetchone()[0]

    return contains

def get_address(connection, packet):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)

    return connection.sql(f"SELECT * FROM packets WHERE "
                              f"source_ip = '{source_ip}' AND "
                              f"destination_ip = '{destination_ip}' AND "
                              f"source_mac = '{source_mac}' AND "
                              f"destination_mac = '{destination_mac}' AND "
                              f"source_port = '{source_port}' AND "
                              f"destination_port = '{destination_port}'").fetchone()

def remove_address(connection, packet):
    destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port = extract_info(packet)

    connection.sql(f"DELETE FROM packets WHERE "
                              f"source_ip = '{source_ip}' AND "
                              f"destination_ip = '{destination_ip}' AND "
                              f"source_mac = '{source_mac}' AND "
                              f"destination_mac = '{destination_mac}' AND "
                              f"source_port = '{source_port}' AND "
                              f"destination_port = '{destination_port}'")

def extract_info(packet):
    source_ip = packet[IP].src if IP in packet else UNDEFINED
    destination_ip = packet[IP].dst if IP in packet else UNDEFINED
    source_mac = packet[Ether].src if Ether in packet else UNDEFINED
    destination_mac = packet[Ether].dst if Ether in packet else UNDEFINED
    source_port = packet[TCP].sport if TCP in packet else UNDEFINED
    destination_port = packet[TCP].dport if TCP in packet else UNDEFINED
    return destination_ip, destination_mac, destination_port, source_ip, source_mac, source_port

def commit(connection):
    connection.commit()